% Serie 10 - Aufgabe 3
% Martin Jochum 2501035, Karsten Khn 2501044
close all;
clear all;
clc;

for cnt = 1:7
    % Bestimmen der numerischen Lsung
    h      = 2^(-(cnt + 1));
    g(cnt) = solve2d(genDir(genRhs(grid2d(1, 1, h, h))));
end

for cnt = 1:7
    % Auswertung der analytischen Lsung in den Gitterpunkten
    for rowCnt = 1 : g(cnt).yCnt
        for colCnt = 1 : g(cnt).xCnt
            var = g(cnt).varNum(rowCnt, colCnt);
            g(cnt).u(var, 1) = g(cnt).x(colCnt)^3 * g(cnt).y(rowCnt)^6 + 0.13e2 * cos(g(cnt).x(colCnt)^2 - g(cnt).y(rowCnt));
        end
    end

    % Bestimmung des Fehlers in der euklidischen und in der
    % Maximumsnorm
    err_euk(cnt) = norm(g(cnt).u - g(cnt).uh, 2);
    err_max(cnt) = norm(g(cnt).u - g(cnt).uh, inf);
end

% Ausgabe der numerischen Lsungen ber dem Ort x und des Fehlers e in
% Abhngigkeit von der Gitterweit h (doppelt-logarithmisch)
figure;
subplot(1,2,1);
surf(g(end).x, g(end).y, g(end).solution, 'EdgeAlpha', 0);
view(2);
title('numerische Lsung');
xlabel('x');
ylabel('y');
zlabel('u');

subplot(1,2,2);
plot(2:8, log10(err_euk), 'b', 2:8, log10(err_max), 'g');
title('Fehler e_2 bzw. e_{\infty} ber Gitterweit h (doppelt-logarithmischer Mastab)', 'interpreter', 'tex');
grid on;
xlabel('Gitterweite h');
set(gca,'XTick',2:8);
set(gca,'XTickLabel',num2str(2.^(-(2:8)')));
set(gca,'YTick',-5:-1);
set(gca,'YTickLabel',num2str(10.^(-5:-1)'));
ylabel('Fehler e');
legend('e_2', 'e_{\infty}');
